/*
 * Copyright 1998,1999 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */

#ifndef _PT_PORTABLE_H
#define _PT_PORTABLE_H

/* end of preamble */

@TOP@

/* define this if needed to get reentrant functions */
#ifndef REENTRANT
#undef REENTRANT
#endif
#ifndef _REENTRANT
#undef _REENTRANT
#endif

/* define this if needed to get threadsafe functions */
#ifndef THREADSAFE
#undef THREADSAFE
#endif
#ifndef _THREADSAFE
#undef _THREADSAFE
#endif
#ifndef THREAD_SAFE
#undef THREAD_SAFE
#endif
#ifndef _THREAD_SAFE
#undef _THREAD_SAFE
#endif

#ifndef _SGI_MP_SOURCE
#undef _SGI_MP_SOURCE
#endif

/* define this if TIOCGWINSZ is defined in sys/ioctl.h */
#undef GWINSZ_IN_SYS_IOCTL

/* These are defined in port_threads_features.h */
/*
	PT_API_FEATURE_X_OPENPT_REENTRANT
	PT_API_FEATURE_X_OPENPT_THREAD_SAFE
	PT_API_FEATURE_X_OPENPT_V2_DNS
	PT_API_FEATURE_X_OPENPT_V2_KBIND
	PT_API_FEATURE_X_OPENPT_V2_REFERRALS
*/

/* These are defined in lber_types.h */
/*
	LBER_INT_T
	LBER_LEN_T
	LBER_SOCKET_T
	LBER_TAG_T
*/

/* define to character address type */
#undef caddr_t

/* define to signed size type */
#undef ssize_t


/* Leave that blank line there!!  Autoheader needs it. */

@BOTTOM@

/* begin of postamble */

#ifdef _WIN32
	/* don't suck in all of the win32 api */
#	define WIN32_LEAN_AND_MEAN 1
#endif

#ifndef __NEED_PROTOTYPES
/* force PT_P to always include prototypes */
#define __NEED_PROTOTYPES 1
#endif

#ifdef HAVE_STDDEF_H
#	include <stddef.h>
#endif

#if defined(PT_DEVEL) && !defined(PT_TEST)
#define PT_TEST
#endif
#if defined(PT_TEST) && !defined(PT_DEBUG)
#define PT_DEBUG
#endif

#include "port_threads_cdefs.h"
#include "port_threads_features.h"

#include "ac/assert.h"

#endif /* _PT_PORTABLE_H */
