/* Generic assert.h */
/* $OpenLDAP: pkg/ldap/include/ac/assert.h,v 1.11 1999/11/27 22:40:09 hyc Exp $ */
/*
 * Copyright 1999 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */

#ifndef _AC_ASSERT_H
#define _AC_ASSERT_H

#undef assert

#ifdef PORT_DEBUG

#if defined( HAVE_ASSERT_H ) || defined( STDC_HEADERS )

#undef NDEBUG
#include <assert.h>

#else /* !(HAVE_ASSERT_H || STDC_HEADERS) */

#define PORT_NEED_ASSERT 1

/*
 * no assert()... must be a very old compiler.
 * create a replacement and hope it works
 */

LIBLBER_F (void) ber_pvt_assert PORT_P(( const char *file, int line,
					 const char *test ));

/* Can't use PORT_STRING(test), that'd expand to "test" */
#if defined(__STDC__) || defined(__cplusplus)
#define assert(test) \
	((test) ? (void)0 : ber_pvt_assert( __FILE__, __LINE__, #test ) )
#else
#define assert(test) \
	((test) ? (void)0 : ber_pvt_assert( __FILE__, __LINE__, "test" ) )
#endif

#endif /* (HAVE_ASSERT_H || STDC_HEADERS) */

#else /* !PORT_DEBUG */
/* no asserts */
#define assert(test) ((void)0)
#endif /* PORT_DEBUG */

#endif /* _AC_ASSERT_H */
