/* Generic signal.h */
/* $OpenLDAP: pkg/ldap/include/ac/signal.h,v 1.12 1999/10/31 01:26:42 hyc Exp $ */
/*
 * Copyright 1998,1999 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */

#ifndef _AC_SIGNAL_H
#define _AC_SIGNAL_H

#include <signal.h>

#undef SIGNAL
#ifdef HAVE_SIGSET
#define SIGNAL sigset
#else
#define SIGNAL signal
#endif

#if !defined( PORT_SIGUSR1 ) || !defined( PORT_SIGUSR2 )
#undef PORT_SIGUSR1
#undef PORT_SIGUSR2

#	if defined(WINNT) || defined(_WINNT) || defined(_WIN32)
#		define PORT_SIGUSR1	SIGILL
#		define PORT_SIGUSR2	SIGTERM

#	elif !defined(HAVE_LINUX_THREADS)
#		define PORT_SIGUSR1	SIGUSR1
#		define PORT_SIGUSR2	SIGUSR2

#	else
		/*
		LinuxThreads implemented unfortunately uses the only
		two signals reserved for user applications.  This forces
		OpenLDAP to use, hopefullly unused, signals reserved
		for other uses.
		*/
	    
#		if defined( SIGSTKFLT )
#			define PORT_SIGUSR1	SIGSTKFLT
#		elif defined ( SIGSYS )
#			define PORT_SIGUSR1	SIGSYS
#		endif

#		if defined( SIGUNUSED )
#			define PORT_SIGUSR2	SIGUNUSED
#		elif defined ( SIGINFO )
#			define PORT_SIGUSR2	SIGINFO
#		elif defined ( SIGEMT )
#			define PORT_SIGUSR2	SIGEMT
#		endif
#	endif
#endif

#ifndef PORT_SIGCHLD
#ifdef SIGCHLD
#define PORT_SIGCHLD SIGCHLD
#elif SIGCLD
#define PORT_SIGCHLD SIGCLD
#endif
#endif

#endif /* _AC_SIGNAL_H */
