/* Generic wait.h */
/* $OpenLDAP: pkg/ldap/include/ac/wait.h,v 1.7 1999/08/30 06:08:00 kdz Exp $ */
/*
 * Copyright 1998,1999 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */

#ifndef _AC_WAIT_H
#define _AC_WAIT_H

#include <sys/types.h>

#if HAVE_SYS_WAIT_H
# include <sys/wait.h>
#endif

#define PORT_HI(s)	(((s) >> 8) & 0377)
#define PORT_LO(s)	((s) & 0377)

/* These should work on non-POSIX UNIX platforms,
	all bets on off on non-POSIX non-UNIX platforms... */
#ifndef WIFEXITED
# define WIFEXITED(s)	(PORT_LO(s) == 0)
#endif
#ifndef WEXITSTATUS
# define WEXITSTATUS(s) PORT_HI(s)
#endif
#ifndef WIFSIGNALED
# define WIFSIGNALED(s) (PORT_LO(s) > 0 && PORT_HI(s) == 0)
#endif
#ifndef WTERMSIG
# define WTERMSIG(s)	(PORT_LO(s) & 0177)
#endif
#ifndef WIFSTOPPED
# define WIFSTOPPED(s)	(PORT_LO(s) == 0177 && PORT_HI(s) != 0)
#endif
#ifndef WSTOPSIG
# define WSTOPSIG(s)	PORT_HI(s)
#endif

#ifdef WCONTINUED
# define WAIT_FLAGS ( WNOHANG | WUNTRACED | WCONTINUED )
#else
# define WAIT_FLAGS ( WNOHANG | WUNTRACED )
#endif

#endif /* _AC_WAIT_H */
