/* $OpenLDAP: pkg/ldap/include/port_cdefs.h,v 1.15 1999/12/18 18:49:13 kdz Exp $ */
/*
 * Copyright 1998,1999 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */
/* PortThreads C Defines */

/*
	PortThreads is derived from the portability layer of the OpenLDAP project.
	this is an attempt to make it more generalized and useful to other apps.
*/

#ifndef _PORT_CDEFS_H
#define _PORT_CDEFS_H

#if defined(__cplusplus) || defined(c_plusplus)
#	define PORT_BEGIN_DECL	extern "C" {
#	define PORT_END_DECL	}
#else
#	define PORT_BEGIN_DECL	/* begin declarations */
#	define PORT_END_DECL	/* end declarations */
#endif

#if !defined(__NO_PROTOTYPES) && ( defined(__NEED_PROTOTYPES) || \
	defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus) )

	/* ANSI C or C++ */
#	define PORT_P(protos)	protos
#	define PORT_CONCAT1(x,y)	x ## y
#	define PORT_CONCAT(x,y)	PORT_CONCAT1(x,y)
#	define PORT_STRING(x)	#x /* stringify without expanding x */
#	define PORT_XSTRING(x)	PORT_STRING(x) /* expand x, then stringify */

#ifndef PORT_CONST
#	define PORT_CONST	const
#endif

#else /* no prototypes */

	/* traditional C */
#	define PORT_P(protos)	()
#	define PORT_CONCAT(x,y)	x/**/y
#	define PORT_STRING(x)	"x"

#ifndef PORT_CONST
#	define PORT_CONST	/* no const */
#endif

#endif /* no prototypes */

#if (__GNUC__) * 1000 + (__GNUC_MINOR__) >= 2006
#	define PORT_GCCATTR(attrs)	__attribute__(attrs)
#else
#	define PORT_GCCATTR(attrs)
#endif


/* Support for NT dynamic libraries. */

/*
 * C library. Mingw32 links with the C run-time library by default,
 * so the explicit definition of CSTATIC will keep dllimport from
 * being defined.
 */
#if (defined(__MINGW32__) && !defined(CSTATIC) || \
     defined(_WIN32) && defined(_DLL))
#	define LIBC_F(type)	extern __declspec(dllimport) type
#else
#	define LIBC_F(type)	extern type
#endif

/* AVL library */
#if defined(LIBAVL_DECL) && defined(_WIN32)
#	define LIBAVL_F(type)	extern __declspec(LIBAVL_DECL) type
#else
#	define LIBAVL_F(type)	extern type
#endif

/* PortThreads library */
#if defined(LIBPORT_DECL) && defined(_WIN32)
#	define LIBPORT_F(type)	extern __declspec(LIBPORT_DECL) type
#else
#	define LIBPORT_F(type)	extern type
#endif

/* PortThreads library */
#if defined(LIBPORT_DECL) && defined(_WIN32)
#	define LIBPORT_EF(type)	extern __declspec(LIBPORT_DECL) type
#else
#	if defined(inline)
/*#		define LIBPORT_EF(type)	extern inline type*/
#		define LIBPORT_EF(type)	inline type
#		define LIBPORT_IF(type)	inline type
#	else
#		define LIBPORT_EF(type)	extern type
#		define LIBPORT_IF(type)	type
#	endif
#endif

/* LUTIL library */
#if defined(LIBLUTIL_DECL) && defined(_WIN32)
#	define LIBLUTIL_F(type)	extern __declspec(LIBLUTIL_DECL) type
#else
#	define LIBLUTIL_F(type)	extern type
#endif

#endif /* _PORT_CDEFS_H */


