/* include/port_threads_features.h.  Generated automatically by configure.  */
/* $OpenLDAP: pkg/ldap/include/ldap_features.h.in,v 1.6 2000/01/08 17:42:17 kdz Exp $ */
/*
 * Copyright 1998,1999 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */
/* 
 * PortThreads Features
 */
#ifndef _PT_FEATURES_H
#define _PT_FEATURES_H 1

/*
** PortThreads reentrancy/thread-safeness should be dynamically
** checked using ldap_get_option().
**
** The -lldap implementation may or may not be:
**		PT_API_FEATURE_THREAD_SAFE
**
** The preprocessor flag PT_API_FEATURE_X_PT_REENTRANT can
** be used to determine if -lport_threads is PT_API_FEATURE_THREAD_SAFE at
** compile time.
**
** The -lport_threads implementation is always THREAD_SAFE but
** may also be:
**		PT_API_FEATURE_SESSION_THREAD_SAFE
**		PT_API_FEATURE_OPERATION_THREAD_SAFE
**
** The preprocessor flag PT_API_FEATURE_X_PT_THREAD_SAFE
** can be used to determine if -lport_threads is available at compile
** time.  You must define PT_THREAD_SAFE if and only if you
** link with -lport_threads.
**
** If you fail to define PT_THREAD_SAFE when linking with
** -lport_threads or define PT_THREAD_SAFE when linking with -lport_threads,
** provided header definations and declarations may be incorrect.
**
*/

/* is -lport_threads reentrant or not */
/* #undef PT_API_FEATURE_X_PT_REENTRANT */

/* is threadsafe version of -lldap (ie: -lldap_r) *available* or not */
/* #undef PT_API_FEATURE_X_PT_THREAD_SAFE */

#endif /* PT_FEATURES */
