#include "port_threads.h"

LIBPORT_IF(int)
port_thread_initialize PORT_P(( void ))
{
	return port_pvt_thread_initialize ();
}

LIBPORT_IF(int)
port_thread_destroy PORT_P(( void ))
{
	return port_pvt_thread_destroy ();
}

LIBPORT_IF(unsigned int)
port_thread_sleep PORT_P(( unsigned int s ))
{
	return port_pvt_thread_sleep (s);
}

#if defined(HAVE_GETCONCURRENCY)
LIBPORT_IF(int)
port_thread_get_concurrency PORT_P(( void ))
{
	return port_pvt_thread_get_concurrency ();
}
#endif /*defined(HAVE_GETCONCURRENCY)*/

#if defined(HAVE_SETCONCURRENCY)
LIBPORT_IF(int)
port_thread_set_concurrency PORT_P(( int con))
{
	return port_pvt_thread_set_concurrency (con);
}
#endif /*defined(HAVE_SETCONCURRENCY)*/

LIBPORT_IF(int)
port_thread_create PORT_P((port_thread_t * thread, 
        int     detach,
	start_routine routine,
        void *arg))
{
	return port_pvt_thread_create (thread,detach,routine,arg);
}

LIBPORT_IF(void)
port_thread_exit PORT_P(( void *retval ))
{
	port_thread_exit (retval);
}

LIBPORT_IF(int)
port_thread_join PORT_P(( port_thread_t thread, void **status ))
{
	return port_pvt_thread_join (thread,status);
}

LIBPORT_IF(int)
port_thread_kill PORT_P(( port_thread_t thread, int signo ))
{
	return port_pvt_thread_kill (thread,signo);
}

LIBPORT_IF(int)
port_thread_yield PORT_P(( void ))
{
	return port_pvt_thread_yield ();
}

#if defined(HAVE_PTHREADS_ATTR_T)
LIBPORT_IF(int)
port_thread_attr_init PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_init ();
}

LIBPORT_IF(int)
port_thread_attr_destroy PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_destroy ();
}

LIBPORT_IF(int)
port_thread_attr_set_scope PORT_P(( port_thread_attr_t *attr, int scope ))
{
	return port_pvt_thread_attr_set_scope ();
}

LIBPORT_IF(int)
port_thread_attr_get_scope PORT_P(( port_thread_attr_t *attr, int scope ))
{
	return port_pvt_thread_attr_get_scope ();
}

LIBPORT_IF(int)
port_thread_attr_set_detachstate PORT_P(( port_thread_attr_t *attr, int state ))
{
	return port_pvt_thread_attr_set_detachstate ();
}

LIBPORT_IF(int)
port_thread_attr_get_detachstate PORT_P(( port_thread_attr_t *attr, int state ))
{
	return port_pvt_thread_attr_get_detachstate ();
}

LIBPORT_IF(int)
port_thread_attr_set_stacksize PORT_P(( port_thread_attr_t *attr, size_t size ))
{
	return port_pvt_thread_attr_set_stacksize ();
}

LIBPORT_IF(int)
port_thread_attr_get_stacksize PORT_P(( port_thread_attr_t *attr, size_t size ))
{
	return port_pvt_thread_attr_get_stacksize ();
}

LIBPORT_IF(int)
port_thread_attr_set_stackaddr PORT_P(( port_thread_attr_t *attr, void *addr ))
{
	return port_pvt_thread_attr_set_stackaddr ();
}

LIBPORT_IF(int)
port_thread_attr_get_stackaddr PORT_P(( port_thread_attr_t *attr, void *addr ))
{
	return port_pvt_thread_attr_get_stackaddr ();
}

#if defined(HAVE_SCHED_POLICY)
LIBPORT_IF(int)
port_thread_attr_set_schedpolicy PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_set_schedpolicy ();
}

LIBPORT_IF(int)
port_thread_attr_get_schedpolicy PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_get_schedpolicy ();
}
#endif /*defined(HAVE_SCHED_POLICY)*/

#if defined(HAVE_INHERIT_SCHED)
LIBPORT_IF(int)
port_thread_attr_set_inheritsched PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_set_inheritsched ();
}

LIBPORT_IF(int)
port_thread_attr_get_inheritsched PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_get_inheritsched ();
}
#endif /*defined(HAVE_INHERIT_SCHED)*/

LIBPORT_IF(int)
port_thread_attr_set_schedparam PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_set_schedparam ();
}

#if defined(HAVE_SCHED_PARAM)
LIBPORT_IF(int)
port_thread_attr_get_schedparam PORT_P(( port_thread_attr_t *attr ))
{
	return port_pvt_thread_attr_get_schedparam ();
}
#endif /*defined(HAVE_SCHED_PARAM)*/
#endif /*defined(HAVE_PTHREADS_ATTR_T)*/

LIBPORT_IF(int)
port_thread_cond_init PORT_P(( port_thread_cond_t *cond , const port_pvt_thread_condattr_t *cond_attr ))
{
	return port_pvt_thread_cond_init (cond,cond_attr);
}

LIBPORT_IF(int)
port_thread_cond_destroy PORT_P(( port_thread_cond_t *cond ))
{
	return port_pvt_thread_cond_destroy (cond);
}

LIBPORT_IF(int)
port_thread_cond_signal PORT_P(( port_thread_cond_t *cond ))
{
	return port_pvt_thread_cond_signal (cond);
}

LIBPORT_IF(int)
port_thread_cond_broadcast PORT_P(( port_thread_cond_t *cond ))
{
	return port_pvt_thread_cond_broadcast (cond);
}

LIBPORT_IF(int)
port_thread_cond_wait PORT_P((port_thread_cond_t *cond, 
	port_thread_mutex_t *mutex ))
{
	return port_pvt_thread_cond_wait (cond,mutex);
}

LIBPORT_IF(int)
port_thread_mutex_init PORT_P(( port_thread_mutex_t *mutex ))
{
	return port_pvt_thread_mutex_init (mutex);
}

LIBPORT_IF(int)
port_thread_mutex_destroy PORT_P(( port_thread_mutex_t *mutex ))
{
	return port_pvt_thread_mutex_destroy (mutex);
}

LIBPORT_IF(int)
port_thread_mutex_lock PORT_P(( port_thread_mutex_t *mutex ))
{
	return port_pvt_thread_mutex_lock (mutex);
}

LIBPORT_IF(int)
port_thread_mutex_trylock PORT_P(( port_thread_mutex_t *mutex ))
{
	return port_pvt_thread_mutex_trylock (mutex);
}

LIBPORT_IF(int)
port_thread_mutex_unlock PORT_P(( port_thread_mutex_t *mutex ))
{
	return port_pvt_thread_mutex_unlock (mutex);
}


LIBPORT_IF(int)
port_thread_rdwr_init PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_init (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_destroy PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_destroy (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_rlock PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_rlock (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_rtrylock PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_rtrylock (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_runlock PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_runlock (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_wlock PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_wlock (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_wtrylock PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_wtrylock (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_wunlock PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_wunlock (rdwrp);
}

#if defined(PORT_THREADS_DEBUG)
LIBPORT_IF(int)
port_thread_rdwr_readers PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_readers (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_writers PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_writers (rdwrp);
}

LIBPORT_IF(int)
port_thread_rdwr_active PORT_P((port_thread_rdwr_t *rdwrp))
{
	return port_pvt_thread_rdwr_active (rdwrp);
}
#endif /*defined(PORT_THREADS_DEBUG)*/


